name: greet
method: POST
access: authenticated
targets:
- name: any
  parameters: 
  - name: GreetingsParameter
    multiplicity: 
      lower-bound: 
        value: 1
      upper-bound: 
        value: 2
        inclusive: true
    properties: 
    - name: name
      description: User name 
      type: string
      constraints:
      - ocl: "self.length < 12"
    - name: email
      description: User email 
      type: string
      constraints:
      - pattern: email
      
    example: |
      [{
        name: 'John Doe',
        email: 'john@doe.net'
      }, {
        name: 'Jane Doe'
      }] 
      
- name: simple
  access: anonymous
  parameters: 
  - name: GreetingsParameter
    properties: 
    - name: hugs
      description: Number of hugs
      type: int
      required: false
      default-value: 1
      contraints:
      - ocl: self >= 0 && self < 5
    example: |
      [{
        name: 'John Doe',
        hugs: 4
      }] 
        
- name: monster
  parameters: 
  - name: GreetingsParameter
    properties: 
    - name: hugs
      description: Number of hugs
      type: int
      required: false
      default-value: 1
      contraints:
      - ocl: self >= 15 
    example: |
      [{
        name: 'John Doe',
        hugs: 21
      }]  
            
- name: adaptive
  parameters: 
  - name: GreetingsParameter
    properties: 
    - name: level
      description: Level of language  
      type: string
      values: 
      - ACADEMIC
      - FORMAL
      - COLLOQUIAL
      - STREET_LINGO
      required: true
    - name: validity
      description: Greetings expiration date
      type: Date
      required: false
      default-value: now() 
      constraints: 
      - ocl: self >= now()
    constraints:
    - ocl: "self.level = STREET_LINGO implies self.validity < now() + 1 hour"
    
    example: |
      [{
        name: 'John Doe',
        level: 'COLLOQUIAL',
        validity: '2019-12-31T23:59:59.000Z'
      }, {
        name: 'Ghostface Killah',
        level: 'STREET_LINGO',
        validity: '2019-06-29T10:45:00.000Z'
      }] 
